package nc.impl.pub.ace;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import nc.bs.dao.BaseDAO;
import nc.bs.framework.common.NCLocator;
import nc.bs.ypff.ordernodz.ace.bp.AceOrdernodzDeleteBP;
import nc.bs.ypff.ordernodz.ace.bp.AceOrdernodzInsertBP;
import nc.bs.ypff.ordernodz.ace.bp.AceOrdernodzUpdateBP;
import nc.impl.pubapp.pattern.data.bill.tool.BillTransferTool;
import nc.vo.ypff.dzd.AggDzdVO;
import nc.vo.ypff.dzd.DzdVO;
import nc.vo.ypff.dzd.KpqdVO;
import nc.vo.ypff.dzd.SkqdVO;
import nc.impl.pubapp.pattern.data.bill.BillLazyQuery;
import nc.ui.querytemplate.querytree.IQueryScheme;
import nc.vo.pub.BusinessException;
import nc.vo.pub.VOStatus;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.pubapp.query2.sql.process.QuerySchemeProcessor;
import nc.impl.pubapp.pattern.database.DataAccessUtils;
import nc.vo.pubapp.pattern.data.IRowSet;
import nc.vo.pubapp.bill.pagination.PaginationTransferObject;
import nc.vo.pubapp.bill.pagination.util.PaginationUtils;
import nc.impl.pubapp.pattern.data.bill.BillQuery;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.BeanListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;

public abstract class AceOrdernodzPubServiceImpl {
    //
    public AggDzdVO[] pubinsertBills(AggDzdVO[] vos) throws BusinessException {
        try {
          // ݿݺǰ̨ݹĲVOϲĽ
          BillTransferTool<AggDzdVO> transferTool =new BillTransferTool<AggDzdVO>(vos);
          AggDzdVO[] mergedVO = transferTool.getClientFullInfoBill();

          // BP
          AceOrdernodzInsertBP action = new AceOrdernodzInsertBP();
          AggDzdVO[] retvos = action.insert(mergedVO);
          // 췵
          return transferTool.getBillForToClient(retvos);
        }catch (Exception e) {
          ExceptionUtils.marsh(e);
        }
        return null;
    }
    //ɾ
    public void pubdeleteBills(AggDzdVO[] vos) throws BusinessException {
        try {
			          //  Ƚts
          BillTransferTool<AggDzdVO> transferTool = new BillTransferTool<AggDzdVO>(vos);
          AggDzdVO[] fullBills = transferTool.getClientFullInfoBill();
          AceOrdernodzDeleteBP deleteBP = new AceOrdernodzDeleteBP();
          deleteBP.delete(fullBills);
        }catch (Exception e) {
          ExceptionUtils.marsh(e);
        }
    }
  	  //޸
    public AggDzdVO[] pubupdateBills(AggDzdVO[] vos) throws BusinessException {
        try {
    	      // + ts
		          BillTransferTool<AggDzdVO> transTool = new BillTransferTool<AggDzdVO>(vos);
		          //ȫǰ̨VO
          AggDzdVO[] fullBills = transTool.getClientFullInfoBill();
	          //޸ǰvo
          AggDzdVO[] originBills = transTool.getOriginBills();
          // BP
          AceOrdernodzUpdateBP bp = new AceOrdernodzUpdateBP();
          AggDzdVO[] retBills = bp.update(fullBills, originBills);
          // 췵
          retBills = transTool.getBillForToClient(retBills);
          return retBills;
        }catch (Exception e) {
          ExceptionUtils.marsh(e);
        }
          return null;
     }


  public AggDzdVO[] pubquerybills(IQueryScheme queryScheme)
      throws BusinessException {

	    AggDzdVO[] bills = null;
	    try {
	      this.preQuery(queryScheme);
	      BillLazyQuery<AggDzdVO> query =
	          new BillLazyQuery<AggDzdVO>(AggDzdVO.class);
	      
	      QuerySchemeProcessor processor = new QuerySchemeProcessor(queryScheme);
	      //bills = query.query(queryScheme, null);
	      
	      
	      
	      /**
	       *
	       */
	      BaseDAO baseDAO = new BaseDAO();
	      IUAPQueryBS iuapbs=(IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	      String sqlpart = processor.getFinalFromWhere();
	      //add by ZTH 2022-08-15 ʾѯ
	
	      String isye=sqlpart.indexOf("isye")!=-1? sqlpart.indexOf("AND ypff_dzd_h.isye = 'Y'")!=-1 ? "Y":"N"  
	    		  :  "YPFFNAN";
	      String str1 =  sqlpart.substring(sqlpart.indexOf("(")+1, sqlpart.lastIndexOf(") ")).replace("AND ypff_dzd_h.isye = 'Y'", "").replace("AND ypff_dzd_h.isye = 'N'", "") ;;
	      String str2 = str1.replace("ypff_dzd_h.pk_org","puorg.pk_financeorg");
	      String str3 = str2.replace("ypff_dzd_h.kjqj","x1.accperiod <");
	      String str4 = str3.replace("ypff_dzd_h.customer", "bdcustonmer.pk_customer");
	     
	      int index1=sqlpart.indexOf("AND");
	      int index2=sqlpart.indexOf("AND",index1+3);
	      if(-1==index2){
	    	  index2=sqlpart.indexOf(")",index1+3);  
	      }
	      
	      String kjqjs=sqlpart.substring(index1+3, index2);
	      String kjqjda=kjqjs.substring(kjqjs.indexOf("=")+1).replace("'", "").trim();
	      
	      StringBuffer dzd = new StringBuffer();
	      dzd.append(" SELECT ");
	      dzd.append(" sum( x1.init_loc ) vdef1, ");
	      dzd.append(" puorg.pk_financeorg pk_org, ");
	      dzd.append(" bdcustonmer.pk_customer customer  ");
	      dzd.append(" FROM ");
	      dzd.append(" ( ");
	      dzd.append(" SELECT ");
	      dzd.append(" arap_balance.pk_group, ");
	      dzd.append(" arap_balance.pk_org, ");
	      dzd.append(" arap_balance.customer qryobj0pk, ");
	      dzd.append(" arap_balance.pk_currtype, ");
	      dzd.append(" 0 rn, + sum( arap_balance.quantity_de - arap_balance.quantity_cr ) init_qua, + sum( arap_balance.money_de - arap_balance.money_cr ) init_ori, + sum( arap_balance.local_money_de - arap_balance.local_money_cr ) init_loc, + sum( arap_balance.grouplocal_money_de - arap_balance.grouplocal_money_cr ) gr_init_loc, + sum( arap_balance.globallocal_money_de - arap_balance.globallocal_money_cr ) gl_init_loc, ");
	      dzd.append(" 0 debt_qua, ");
	      dzd.append(" 0.0 debt_ori, ");
	      dzd.append(" 0.0 debt_loc, ");
	      dzd.append(" 0.0 gr_debt_loc, ");
	      dzd.append(" 0.0 gl_debt_loc, ");
	      dzd.append(" 0 credit_qua, ");
	      dzd.append(" 0.0 credit_ori, ");
	      dzd.append(" 0.0 credit_loc, ");
	      dzd.append(" 0.0 gr_credit_loc, ");
	      dzd.append(" 0.0 gl_credit_loc, ");
	      dzd.append(" arap_balance.accperiod  ");
	      dzd.append(" FROM ");
	      dzd.append(" ( ");
	      dzd.append(" SELECT ");
	      dzd.append(" ACCMONTH, ");
	      dzd.append(" ACCPERIOD, ");
	      dzd.append(" ACCYEAR, ");
	      dzd.append(" BILLCLASS, ");
	      dzd.append(" BILLSTATUS, ");
	      dzd.append(" COMPONDMD5, ");
	      dzd.append(" CUSTOMER, ");
	      dzd.append(" DEF1, ");
	      dzd.append(" DEF2, ");
	      dzd.append(" DEF3, ");
	      dzd.append(" DEF4, ");
	      dzd.append(" DEF5, ");
	      dzd.append(" DEF6, ");
	      dzd.append(" DR, ");
	      dzd.append(" EFFECTSTATUS, ");
	      dzd.append(" GLOBALLOCAL_MONEY_CR, ");
	      dzd.append(" GLOBALLOCAL_MONEY_DE, ");
	      dzd.append(" GROUPLOCAL_MONEY_CR, ");
	      dzd.append(" GROUPLOCAL_MONEY_DE, ");
	      dzd.append(" LOCAL_MONEY_CR, ");
	      dzd.append(" LOCAL_MONEY_DE, ");
	      dzd.append(" MONEY_CR, ");
	      dzd.append(" MONEY_DE, ");
	      dzd.append(" OBJTYPE, ");
	      dzd.append(" PK_BALANCE, ");
	      dzd.append(" PK_CURRTYPE, ");
	      dzd.append(" PK_DEPTID, ");
	      dzd.append(" PK_GROUP, ");
	      dzd.append(" PK_ORG, ");
	      dzd.append(" PK_ORG_V, ");
	      dzd.append(" PK_PSNDOC, ");
	      dzd.append(" QUANTITY_CR, ");
	      dzd.append(" QUANTITY_DE, ");
	      dzd.append(" SUPPLIER, ");
	      dzd.append(" TS ");
	      dzd.append(" FROM ");
	      dzd.append(" ARAP_BALANCE UNION ALL ");
	      dzd.append(" SELECT ");
	      dzd.append(" ACCMONTH, ");
	      dzd.append(" ACCPERIOD, ");
	      dzd.append(" ACCYEAR, ");
	      dzd.append(" BILLCLASS, ");
	      dzd.append(" BILLSTATUS, ");
	      dzd.append(" COMPONDMD5, ");
	      dzd.append(" CUSTOMER, ");
	      dzd.append(" DEF1, ");
	      dzd.append(" DEF2, ");
	      dzd.append(" DEF3, ");
	      dzd.append(" DEF4, ");
	      dzd.append(" DEF5, ");
	      dzd.append(" DEF6, ");
	      dzd.append(" DR, ");
	      dzd.append(" EFFECTSTATUS, ");
	      dzd.append(" GLOBALLOCAL_MONEY_CR, ");
	      dzd.append(" GLOBALLOCAL_MONEY_DE, ");
	      dzd.append(" GROUPLOCAL_MONEY_CR, ");
	      dzd.append(" GROUPLOCAL_MONEY_DE, ");
	      dzd.append(" LOCAL_MONEY_CR, ");
	      dzd.append(" LOCAL_MONEY_DE, ");
	      dzd.append(" MONEY_CR, ");
	      dzd.append(" MONEY_DE, ");
	      dzd.append(" OBJTYPE, ");
	      dzd.append(" PK_BALANCE, ");
	      dzd.append(" PK_CURRTYPE, ");
	      dzd.append(" PK_DEPTID, ");
	      dzd.append(" PK_GROUP, ");
	      dzd.append(" PK_ORG, ");
	      dzd.append(" PK_ORG_V, ");
	      dzd.append(" PK_PSNDOC, ");
	      dzd.append(" QUANTITY_CR, ");
	      dzd.append(" QUANTITY_DE, ");
	      dzd.append(" SUPPLIER, ");
	      dzd.append(" TS  ");
	      dzd.append(" FROM ");
	      dzd.append(" ARAP_BALANCE2  ");
	      dzd.append(" ) arap_balance  ");
	      dzd.append(" WHERE ");
	      dzd.append(" 1 = 1  ");
	      dzd.append(" AND arap_balance.billclass IN ( 'ys', 'zs', 'sk' )  ");
	      dzd.append(" AND arap_balance.customer <> '~'  ");
	      dzd.append(" AND 1 = 1  ");
	      dzd.append(" AND arap_balance.objtype = 0  ");
	      dzd.append(" GROUP BY ");
	      dzd.append(" arap_balance.pk_group, ");
	      dzd.append(" arap_balance.pk_org, ");
	      dzd.append(" arap_balance.customer, ");
	      dzd.append(" arap_balance.pk_currtype, ");
	      dzd.append(" arap_balance.accperiod ");
	      dzd.append(" 	) x1 ");
	      dzd.append(" INNER JOIN org_financeorg puorg ON puorg.pk_financeorg = x1.pk_org ");
	      dzd.append(" INNER JOIN bd_customer bdcustonmer ON bdcustonmer.pk_customer = x1.qryobj0pk  ");
	      dzd.append(" AND ");
	      dzd.append(str4);
	      dzd.append(" GROUP BY ");
	      dzd.append(" puorg.pk_financeorg, ");
	      dzd.append(" bdcustonmer.pk_customer ");
	        List<DzdVO> dzdVOList = (List<DzdVO>) baseDAO.executeQuery(dzd.toString(),new BeanListProcessor(DzdVO.class));   
/*	        AggDzdVO[] aggDzdVOarr = new AggDzdVO[dzdVOList.size()];
	        for (int i = 0; i < dzdVOList.size(); i++) {
	        	AggDzdVO aggDzdVO = new AggDzdVO();
	        	aggDzdVO.setParent(dzdVOList.get(i));
	        	aggDzdVOarr[i] = aggDzdVO;
	  	}
	      */  
	        //add by ZTH add by ZTH 2022-08-15 ʾ
	        List<AggDzdVO> aggDzdVOListye =new ArrayList<AggDzdVO>();
	      
	        String str5 = str1.replace("ypff_dzd_h","arb");
		    String str6 = str5.replace("arb.kjqj","substr( arh.billdate, 0, 7 )");
		    //ȡͻַ±
		    int left = str6.indexOf("arb.customer");
/*	        for (int i = 0; i < aggDzdVOarr.length; i++) {
	        	String customer = (String) aggDzdVOarr[i].getParent().getAttributeValue("customer");*/
		    for (int i = 0; i < dzdVOList.size(); i++) {
		    	AggDzdVO aggDzdVO = new AggDzdVO();
		    	String customer = (String) dzdVOList.get(i).getAttributeValue("customer");
		    	
	        	StringBuffer skqd =  new StringBuffer();
	     	    skqd.append(" SELECT ");
	     	    skqd.append(" arb.customer customer, ");
	     	    skqd.append(" substr( arh.billdate, 0, 10 ) skdate, ");
	     	    skqd.append(" bd_balatype.name skstyle, ");
	     	    skqd.append(" arh.money jemoy  ");
	     	    skqd.append(" FROM ");
	     	    skqd.append(" ar_gatheritem arb ");
	     	    skqd.append(" INNER JOIN ar_gatherbill arh ON arh.pk_gatherbill = arb.pk_gatherbill ");
	     	    skqd.append(" INNER JOIN bd_balatype ON bd_balatype.pk_balatype = arb.pk_balatype ");
	     	    skqd.append(" INNER JOIN org_financeorg puorg ON puorg.pk_financeorg = arh.pk_org ");
	     	    skqd.append(" AND nvl( arb.dr, 0 ) = 0 ");
	     	    skqd.append(" AND nvl( arh.dr, 0 ) = 0 ");
	     	    skqd.append(" AND nvl( puorg.dr, 0 ) = 0 ");
	     	    //滻ͻѯ޻ȡͻƴ
	     	    if(left != -1) {
	     	    	String str7 = str6.substring(str6.indexOf("arb.customer"));
	     	    	String str8 = str6.replace(str7,"arb.customer = '"+customer+"'");
	     	    	skqd.append("AND "+str8);
	     	    }else {
	     	    	skqd.append("AND "+str6);
	     	    	skqd.append("AND arb.customer = '"+customer+"'");
	     	    }
	     	    skqd.append(" GROUP BY ");
	     	    skqd.append(" arb.customer, ");
	     	    skqd.append(" substr( arh.billdate, 0, 10 ), ");
	     	    skqd.append(" bd_balatype.name, ");
	     	    skqd.append(" arh.money  ");
	     	    skqd.append(" ORDER BY ");
	     	    skqd.append(" arb.customer, ");
	     	    skqd.append(" substr( arh.billdate, 0, 10 ) ");
	        	
	     	    List<SkqdVO> skqdVOList = (List<SkqdVO>) baseDAO.executeQuery(skqd.toString(),new BeanListProcessor(SkqdVO.class));
	     	    SkqdVO[] SkqdVOarr = new SkqdVO[skqdVOList.size()];
	     	    for (int j = 0; j < skqdVOList.size(); j++) {
	     	    	SkqdVOarr[j] = skqdVOList.get(j);
	     	    }
	     //	    aggDzdVOarr[i].setChildren(SkqdVO.class, SkqdVOarr);
	     	    
	     	    
	     	  
	     	    String str7 = str1.replace("ypff_dzd_h","soh");
	     	    String str8 = str7.replace("soh.kjqj","substr( soh.dbilldate, 0, 7 )");
	     	    StringBuffer kpqd =  new StringBuffer();
	     	    kpqd.append(" SELECT ");
	     	    kpqd.append(" soh.cinvoicecustid customer, ");
	     	    kpqd.append(" substr( soh.dbilldate, 0, 10 ) kpdate, ");
	     	    kpqd.append(" soh.vgoldtaxcode fpcode, ");
	     	    kpqd.append(" soh.ntotalorigmny jsmoney  ");
	     	    kpqd.append(" FROM ");
	     	    kpqd.append(" so_saleinvoice soh ");
	     	    kpqd.append(" INNER JOIN bd_customer bdcustonmer ON bdcustonmer.pk_customer = soh.cinvoicecustid ");
		     	kpqd.append(" INNER JOIN org_financeorg puorg ON puorg.pk_financeorg = soh.pk_org  ");
		     	kpqd.append(" AND nvl( soh.dr, 0 ) = 0  ");
		     	kpqd.append(" AND nvl( puorg.dr, 0 ) = 0 ");
		     	if(left != -1) {
		     		String str9 = str8.substring(str8.indexOf("soh.customer")-1);
		     		String str10 = str8.replace(str9," soh.cinvoicecustid = '"+customer+"'");
		     		kpqd.append("AND "+str10);
		     	}else {
		     		kpqd.append("AND "+str8);
		     		kpqd.append("AND soh.cinvoicecustid = '"+customer+"'");
		     	}
		     	kpqd.append(" GROUP BY ");
		     	kpqd.append(" soh.cinvoicecustid, ");
		     	kpqd.append(" substr( soh.dbilldate, 0, 10 ), ");
		     	kpqd.append(" soh.vgoldtaxcode, ");
		     	kpqd.append(" soh.ntotalorigmny ");
		     	kpqd.append(" ORDER BY ");
		     	kpqd.append(" soh.cinvoicecustid ");
		     	List<KpqdVO> kpqdVOList = (List<KpqdVO>) baseDAO.executeQuery(kpqd.toString(),new BeanListProcessor(KpqdVO.class));
		     	KpqdVO[] kpqdVOarr = new KpqdVO[kpqdVOList.size()];
		     	for (int k = 0; k < kpqdVOList.size(); k++) {
		     		kpqdVOarr[k] = kpqdVOList.get(k);
		     	}
		 //    	aggDzdVOarr[i].setChildren(KpqdVO.class, kpqdVOarr);
		     	
		     	if("Y".equals(isye)&& null!=SkqdVOarr 
		     			&& SkqdVOarr.length==0 && null!=kpqdVOarr && kpqdVOarr.length==0){
		     		continue;
		     		
		     	}
		     	
		     	String sqlkjqj="select pk_accperiodmonth  from bd_accperiodmonth where yearmth ='"+kjqjda+"' and isnull(dr,0)=0 " ;
		     	//ڼ 
		     	dzdVOList.get(i).setKjqj(iuapbs.executeQuery(sqlkjqj, new ColumnProcessor()).toString());
		     	aggDzdVO.setParentVO(dzdVOList.get(i));
		     	aggDzdVO.setChildren(SkqdVO.class, SkqdVOarr);
		    	aggDzdVO.setChildren(KpqdVO.class, kpqdVOarr);
		    	aggDzdVOListye.add(aggDzdVO);
   	
	        }
//	      bills = aggDzdVOarr;
		    
		    
		    bills = aggDzdVOListye.toArray(new AggDzdVO[0]);
		    
	    }
	    catch (Exception e) {
	      ExceptionUtils.marsh(e);
	    }
	    return bills;
	  }


	  /**
   * ʵ֣ѯ֮ǰquerySchemeмӹԼ߼
   * 
   * @param queryScheme
   */
  protected void preQuery(IQueryScheme queryScheme) {
    // ѯ֮ǰquerySchemeмӹԼ߼
  }

				
}